/*
* ITG3200
*   SCL => Analog 05
*   SDA => Analog 04
*   CLK => GND
*   INT => not connected
*   GND => GND
*   VIO => 3.3V
*   VDD => 3.3V
* Processing ---- FreeIMU1_P
* Arduino Duemilanove ---- FreeIMU1_A
*/

//#define DEBUG
#include "DebugUtils.h"

#include "FreeIMU1.h"
#include <Wire.h>

int raw_values[9];
char str[512];
float q[4];
float val[9];

#define PERIOD 40 // 25Hz sampling

// Set the default object
FreeIMU my3IMU = FreeIMU();

boolean setinitq = true;
char char1;
int phideg, phideg_1, phideg_2;
float init_q0;

void setup(){ 
  Serial.begin(115200);
  Wire.begin();
  delay(2000);
  my3IMU.init();
  delay(2000);
}

void loop(){ 
 if(Serial.available()>2){
    char1 = char(Serial.read());
    phideg_1 = Serial.read();
    phideg_2 = Serial.read();
    if(char1=='i'){
      setinitq = true;
      phideg = (phideg_1 << 8) + phideg_2;
      Euler2Quatanion();
    } 
    if(char1=='I'){
      my3IMU.init();
      my3IMU.init();
      my3IMU.init();
      my3IMU.init();
      delay(2000);
      setinitq = true;
      phideg = (phideg_1 << 8) + phideg_2;
      Euler2Quatanion();
    }
  } 

  if(setinitq == true){delay(1000); my3IMU.SetInitQ(init_q0); setinitq = false;}
    
  unsigned long startloop = millis();
  
  /*
  my3IMU.getRawValues(raw_values);
  //sprintf(str, "%d,%d,%d,%d,%d,%d,%d,%d,%d,", (raw_values[0] + 120), (raw_values[1] + 20), (raw_values[2] + 93), raw_values[3], raw_values[4], raw_values[5], raw_values[6], raw_values[7], raw_values[8]); 
  sprintf(str, "%d,%d,%d,%d,%d,%d,%d,%d,%d,", (raw_values[0] -3 ), (raw_values[1] - 15), (raw_values[2] - 230), raw_values[3], raw_values[4], raw_values[5], raw_values[6], raw_values[7], raw_values[8]); 
  Serial.print(str);
  Serial.print(10, BYTE);
  */
  
  /*my3IMU.getValues(val);
  sprintf(str, "%d,%d,%d,%d,%d,%d,%d,%d,%d", int(val[0]), int(val[1]), int(val[2]), int(val[3]), int(val[4]), int(val[5]), int(val[6]), int(val[7]), int(val[8]));  
  Serial.print(str);
  Serial.print(10, BYTE);
  */
  
  my3IMU.getQ(q);
  serialPrintFloatArr(q, 4);
  Serial.println("");
    
  int wait_time = PERIOD - (millis() - startloop);
  if(wait_time > 0) {
    delay(wait_time);
  }
}

void serialPrintFloatArr(float * arr, int length) {
  for(int i=0; i<length; i++) {
    serialFloatPrint(arr[i]);
    Serial.print(",");
  }
}

void serialFloatPrint(float f) {
  byte * b = (byte *) &f;
  Serial.print("f:");
  for(int i=0; i<4; i++) {
    
    byte b1 = (b[i] >> 4) & 0x0f;
    byte b2 = (b[i] & 0x0f);
    
    char c1 = (b1 < 10) ? ('0' + b1) : 'A' + b1 - 10;
    char c2 = (b2 < 10) ? ('0' + b2) : 'A' + b2 - 10;
    
    Serial.print(c1);
    Serial.print(c2);
  }
}

void Euler2Quatanion(){
  float q0, q3;
  float q0_ = 0;
  float plusminus = 1;
  if(phideg>180){phideg = phideg - 360; plusminus = -1;}
  float phirad = phideg * PI / 180;
  float phirad_;
  float q0minconst = 0;
  float q0maxconst = 1;
  float q0min = q0minconst;
  float q0max = q0maxconst;
  float q0increment = (q0max - q0min) / 10;
  float dif;
  float difprev = PI;

  for (int i1 = 0; i1 < 10; i1++){
    for (int i2 = 0; i2 < 10; i2++){
      q0 = q0min + q0increment * i2;
      q3 = sqrt(1-q0*q0);
      phirad_ = - atan2(-2*q0*q3, 2*q0*q0-1);
      dif = abs(abs(phirad_) - abs(phirad));
      if(dif < difprev){q0_ = q0; difprev = dif;}
    }
    q0min = max(q0_ - q0increment, q0minconst);
    q0max = min(q0_ + q0increment, q0maxconst);
    q0increment = (q0max - q0min) / 10;
  }
  init_q0 = plusminus * q0_ ;
  q3 = sqrt(1-init_q0*init_q0);
}
